SystemOrganization addCategory: #'CS528-UT3Base'!

TestCase subclass: #UT3BoardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

UT3BoardTest subclass: #UT3BasicBoardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'ShineLow 7/4/2013 11:55'!
testCreateEmptyBoard
	|board|
	board := UT3BasicBoard new.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'ShineLow 7/4/2013 12:56'!
testPlayOneGameWithColumnWinner
	|board|
	board := UT3BasicBoard new.
	board atRow: 1 column: 1 put: #circle.
	board atRow: 1 column: 2 put: #cross.
	board atRow: 2 column: 1 put: #circle.
	board atRow: 2 column: 2 put: #cross.
	board atRow: 3 column: 3 put: #circle.
	board atRow: 3 column: 2 put: #cross.
	self assert: board movesCount equals: 6.
	self assert: board winner equals: #cross.
	"Cannot change the winner once it's set!!"
	board atRow: 3 column: 1 put: #circle.
	self assert: board winner equals: #cross.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'ShineLow 7/4/2013 12:56'!
testPlayOneGameWithDiagonalWinner
	|board|
	board := UT3BasicBoard new.
	board atRow: 1 column: 1 put: #cross.
	board atRow: 2 column: 1 put: #circle.
	board atRow: 2 column: 2 put: #cross.
	board atRow: 3 column: 1 put: #circle.
	board atRow: 3 column: 3 put: #cross.
	self assert: board movesCount equals: 5.
	self assert: board winner equals: #cross.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'ShineLow 7/4/2013 12:56'!
testPlayOneGameWithRowWinner
	|board|
	board := UT3BasicBoard new.
	board atRow: 1 column: 1 put: #cross.
	board atRow: 1 column: 2 put: #circle.
	board atRow: 2 column: 1 put: #cross.
	board atRow: 1 column: 3 put: #circle.
	board atRow: 3 column: 1 put: #cross.
	self assert: board movesCount equals: 5.
	self assert: board winner equals: #cross.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'ShineLow 7/4/2013 13:21'!
testWinnerChecks
	|board|
	"Win by row"
	1 to: 3 do: [ :column | 
		board := UT3BasicBoard new.
		board atRow: 1 column: column put: #cross.
		board atRow: 2 column: column put: #cross.
		board atRow: 3 column: column put: #cross.
		self assert: board movesCount equals: 3.
		self assert: board winner equals: #cross.
	].
	
	"Win by column"
	1 to: 3 do: [ :row | 
		board := UT3BasicBoard new.
		board atRow: row column: 1 put: #circle.
		board atRow: row column: 2 put: #circle.
		board atRow: row column: 3 put: #circle.
		self assert: board movesCount equals: 3.
		self assert: board winner equals: #circle.
	].

	"Win by top left to bottom right diagonal"
	board := UT3BasicBoard new.
	1 to: 3 do: [ :index | board atRow: index column: index put: #cross].
	self assert: board movesCount equals: 3.
	self assert: board winner equals: #cross.

	board := UT3BasicBoard new.
		1 to: 3 do: [ :index | board atRow: index column: ( 3 - index + 1 ) put: #circle].
	self assert: board movesCount equals: 3.
	self assert: board winner equals: #circle.
! !

!UT3BoardTest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/5/2013 00:46'!
test1TakeTurnsEnforcement

	| board1  |
	board1 := UT3Board new initialize.
	board1 player: 1 moveRow: 5 moveCol: 5.
	board1 player: 2 moveRow: 4 moveCol: 4.
	board1 player: 1 moveRow: 6 moveCol: 5.
	board1 player: 2 moveRow: 5 moveCol: 6.
	board1 player: 1 moveRow: 5 moveCol: 2.
	board1 player: 2 moveRow: 2 moveCol: 8.
	self assert: (board1 ifplayer: 2 moveRow: 2 moveCol: 8) = true.
	self assert: (board1 ifplayer: 1 moveRow: 5 moveCol: 2) = true.
	Transcript open; show: board1.

! !

!UT3BoardTest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/5/2013 00:19'!
test2PrintOn

	| board1  |
	board1 := UT3Board new initialize.
	board1 player: 1 moveRow: 1 moveCol: 1.
	board1 player: 2 moveRow: 4 moveCol: 4.
	board1 player: 1 moveRow: 6 moveCol: 5.
	board1 player: 2 moveRow: 5 moveCol: 6.
	board1 player: 1 moveRow: 5 moveCol: 2.
	board1 player: 2 moveRow: 2 moveCol: 8.
	Transcript open; show: board1.

! !

!UT3BoardTest methodsFor: 'as yet unclassified' stamp: 'Oliver 7/5/2013 00:46'!
test3BoardToPlayEnforcement

	| board1  |
	board1 := UT3Board new initialize.
	board1 player: 1 moveRow: 8 moveCol: 8.
	board1 player: 2 moveRow: 5 moveCol: 5.
	board1 player: 1 moveRow: 6 moveCol: 5.
	board1 player: 2 moveRow: 8 moveCol: 5.
	board1 player: 1 moveRow: 6 moveCol: 4.
	board1 player: 2 moveRow: 8 moveCol: 2.
	board1 player: 1 moveRow: 4 moveCol: 5.
	board1 player: 2 moveRow: 2 moveCol: 5.
	board1 player: 1 moveRow: 6 moveCol: 6.
	board1 player: 2 moveRow: 7 moveCol: 7.
	self assert: (board1 ifplayer: 2 moveRow: 7 moveCol: 7) = true.
	self assert: (board1 ifplayer: 1 moveRow: 6 moveCol: 6) = true.
	Transcript open; show: board1.

! !

UT3BoardTest subclass: #UT3NestedBoardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 17:16'!
testColumnVictories
	|board|
	board := UT3NestedBoard new.
	( 1 to: board size ) do: [ :row |
		(1 to: board size) do: [ :subRow |
			board at: { row. 1 } subBoard: { subRow. 1 } put: #circle
			 ]
		 ].
	self assert: board winner equals: #circle! !

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 17:23'!
testDiagonalVictories
	|board boardSize |
	"Top left to bottom right"
	board := UT3NestedBoard new.
	boardSize := board size.
	( 1 to: boardSize ) do: [ :row |
		(1 to: boardSize) do: [ :subRow |
			board at: { row. row } subBoard: { subRow. subRow } put: #circle
			 ]
		 ].
	self assert: board winner equals: #circle.
	Transcript open; show: board printBoardString .
	
	"Bottom left to top right"
	board := UT3NestedBoard new.
	boardSize := board size.
	( 1 to: boardSize ) do: [ :row |
		(1 to: boardSize) do: [ :subRow |
			board at: { row. boardSize - row + 1 } subBoard: { subRow. boardSize - subRow + 1 } put: #cross
			 ]
		 ].
	self assert: board winner equals: #cross.
	Transcript open; show: board printBoardString ! !

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 18:06'!
testOneGameRound
	| board |
	"End game result will look like
    |    |     ||     |    | x  ||  x | 0 |    
    | x |     ||     | x |     ||     |    | x 
    |    | 0  ||     |    |     ||     |    |    

    |    |     ||  0 | 0 | 0  ||     |    | 0 
 0 | 0 | 0  ||  x | x | x  ||  x | 0 |    
    |    |     ||     |    |     ||  0 |    |    

    |    |     ||     |    |     ||     |    |    
 x |    |     ||     |    |     ||     |    | x 
    |    |     ||     |    |     ||     |    |    
	Where the winner is Circle"
	board := UT3NestedBoard new.
	board at: { 2. 2 } subBoard: { 2. 2 } put: #cross.
	board at: { 2. 2 } subBoard: { 1. 2 } put: #circle.
	board at: { 1. 2 } subBoard: { 1. 3 } put: #cross.
	board at: { 1. 3 } subBoard: { 1. 2 } put: #circle.
	board at: { 1. 2 } subBoard: { 2. 2 } put: #cross.
	board at: { 2. 2 } subBoard: { 1. 1 } put: #circle.
	board at: { 1. 1 } subBoard: { 2. 2 } put: #cross.
	board at: { 2. 2 } subBoard: { 1. 3 } put: #circle.
	"Middle is won by circle"
	self assert: board winner equals: #undecided.
	board at: { 1. 3 } subBoard: { 2. 3 } put: #cross.
	board at: { 2. 3 } subBoard: { 2. 2 } put: #circle.
	board at: { 2. 2 } subBoard: { 2. 3 } put: #cross.
	board at: { 2. 3 } subBoard: { 1. 3 } put: #circle.
	board at: { 1. 3 } subBoard: { 1. 1 } put: #cross.
	board at: { 1. 1 } subBoard: { 3. 3 } put: #circle.
	board at: { 3. 3 } subBoard: { 2. 3 } put: #cross.
	board at: { 2. 3 } subBoard: { 3. 1 } put: #circle.
	"Middle right won by circle"
	self assert: board winner equals: #undecided.
	board at: { 3. 1 } subBoard: { 2. 1 } put: #cross.
	board at: { 2. 1 } subBoard: { 2. 2 } put: #circle.
	board at: { 2. 2 } subBoard: { 2. 1 } put: #cross.
	board at: { 2. 1 } subBoard: { 2. 3 } put: #circle.
	board at: { 2. 3 } subBoard: { 2. 1 } put: #cross.
	board at: { 2. 1 } subBoard: { 2. 1 } put: #circle.
	self assert: board winner equals: #circle.
	Transcript open; show: board.! !

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 17:07'!
testPrintBoardString
	| board1  |
	board1 := UT3NestedBoard new.
	board1 player: 1 moveRow: 1 moveCol: 1.
	board1 player: 2 moveRow: 4 moveCol: 4.
	board1 player: 1 moveRow: 6 moveCol: 5.
	board1 player: 2 moveRow: 5 moveCol: 6.
	board1 player: 1 moveRow: 5 moveCol: 2.
	board1 player: 2 moveRow: 2 moveCol: 8.
	Transcript open; show: board1 printBoardString.! !

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 17:16'!
testRowVictories
	|board|
	board := UT3NestedBoard new.
	( 1 to: board size ) do: [ :column |
		(1 to: board size) do: [ :subColumn |
			board at: { 1. column } subBoard: { 1. subColumn } put: #cross
			 ]
		 ].
	self assert: board winner equals: #cross! !

Error subclass: #MoveError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!MoveError commentStamp: '<historical>' prior: 0!
A MoveError is an Error that is throw when an invalid move happens.

Instance Variables
!

Object subclass: #UT3Board
	instanceVariableNames: 'boardMatrix boardGlobalMatrix turnOfPlayer nextBoardToPlay size movesCount winner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3Board commentStamp: '<historical>' prior: 0!
An UT3Board is a board.

Instance Variables

Here are a few quick reason about why I code them that way and 

what are those magic numbers stand for.

First, the board(boardMatrix in the code) is a 9 * 9 matrix they actually don't need to be nested(although they could) because we could access it really convenient by rows and columns and we could submatrix whenever we want. 
(here is a handy list of matrix functions http://magaloma.seasidehosting.st/Collections-Unordered)

Each cell in the board, say 1 out of 81, has three status: 

0: not played yet. 
1: player 1 marked. 
2: player 2 taken. 

That boardGlobalMatrix is 3 * 3 and design to mark the winning status of the small board, 
it changes and only changes when one (of the two players) win a subarea.   
It is a global marker with global winning status overview... so is named with 'global' in it. !

UT3Board subclass: #UT3BasicBoard
	instanceVariableNames: 'cellMatrix isFull'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3BasicBoard commentStamp: '<historical>' prior: 0!
An UT3BasicBoard is a basic Tic Tac Toe board.
With it, you can play a normal 3 x 3 Tic Tac Toe game.

Instance Variables
	cellMatrix:		<Object>
	isFull:		<Object>
	movesCount:		<Object>
	size:		<Object>
	winner:		<Object>

cellMatrix
	- xxxxx

isFull
	- xxxxx

movesCount
	- xxxxx

size
	- xxxxx

winner
	- xxxxx
!

!UT3BasicBoard class methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 17:04'!
newWithSize: anInteger
	^ self new resetWithSize: anInteger! !

!UT3BasicBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 14:26'!
= aBasicBoard
	^ winner = aBasicBoard winner! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/4/2013 14:58'!
atRow: aRow column: aColumn
	^ cellMatrix at: aRow at: aColumn! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/4/2013 14:29'!
atRow: aRow column: aColumn put: aSymbol 
	| cell |
	self isFull ifTrue: [ MoveError signal: 'Board is full.' ].
	(aSymbol = #circle) | (aSymbol = #cross) ifFalse: [ MoveError signal: 'Unknown move symbol.' ].
	cell := cellMatrix at: aRow at: aColumn.
	cell state = #empty ifFalse: [ MoveError signal: 'Cell already filled.' ].
	( aSymbol = #circle ) ifTrue: [ cell setCircle ] ifFalse: [ cell setCross ].
	movesCount := movesCount + 1.
	"Every time we make a move, we check to see if a winner is already decided"
	self checkWinnerAtRow: aRow column: aColumn matrix: cellMatrix.
	"If this is the last move, and we still don't have a winner, set winner as none"
	(self isFull) & (winner = #undecided) ifTrue: [ winner := #none ]! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/4/2013 13:30'!
canPutAtRow: aRow column: aColumn
	^ (cellMatrix at: aRow at: aColumn) state = #empty! !

!UT3BasicBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 14:27'!
hash
	^ winner hash! !

!UT3BasicBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 11:12'!
initialize
	size := 3. "Default board size is 3x3"
	cellMatrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3Cell new ].
	movesCount := 0.
	winner := #undecided.! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/4/2013 11:20'!
isFull
	^ movesCount = ( size * size )! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/4/2013 12:28'!
movesCount
	^ movesCount! !

!UT3BasicBoard methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 13:20'!
printBoardOn: aStream
	|transposed|
	transposed := cellMatrix transposed.
	transposed indicesDo: [
		:row :column | 
		(transposed at: row at: column) printStateOn: aStream.
		column = size
		ifTrue: [ aStream cr ] 
		ifFalse: [ aStream nextPutAll: '|' ]
		]! !

!UT3BasicBoard methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 16:52'!
printRow: aRow on: aStream
	(cellMatrix atRow: aRow) do: [ :cell | cell printStateOn: aStream ]
							     separatedBy: [ aStream nextPutAll: '|'  ]! !

!UT3BasicBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 17:03'!
resetWithSize: anInteger
	size := anInteger.
	cellMatrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3Cell new ].
	movesCount := 0.
	winner := #undecided.! !

!UT3BasicBoard methodsFor: 'private' stamp: 'ShineLow 7/4/2013 14:23'!
state
	^ winner! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/4/2013 11:20'!
winner
	^ winner! !

!UT3Board methodsFor: 'private' stamp: 'ShineLow 7/4/2013 14:29'!
checkWinnerAtRow: aRow column: aColumn matrix: aMatrix
	|currentWinner diagonalSet|
	winner = #undecided ifFalse: [ ^nil ].
	"Check current row"
	currentWinner := self getWinnerAtSet: ( (aMatrix atRow: aRow) asSet ).
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
	"Check current column"
	currentWinner := self getWinnerAtSet: ( ( aMatrix atColumn: aColumn ) asSet).
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
	"Check diagonals, from top left to bottom right"
	diagonalSet := Set new.
	aRow = aColumn ifTrue:[
		1 to: size do: [ :index | diagonalSet add: ( aMatrix at: index at: index ) ].
		currentWinner := self getWinnerAtSet: diagonalSet.
		currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ]
		].
	"From bottom left to top right"
	diagonalSet := Set new.
	aRow = ( size - aColumn + 1 ) ifTrue: [ 
		1 to: size do: [ :index | diagonalSet add: ( aMatrix at: index at: ( size - index + 1 ) ) ]	.
		currentWinner := self getWinnerAtSet: diagonalSet.
		currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ]
	]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/2/2013 00:24'!
checkWinningWithCol: subMatrix

	| ret1 ret2 ret3 |
	ret1 := (self checkWinningWithSet: ((subMatrix atColumn: 1) asSet)).
	ret2 := (self checkWinningWithSet: ((subMatrix atColumn: 2) asSet)).
	ret3 := (self checkWinningWithSet: ((subMatrix atColumn: 3) asSet)).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[ret3 > 0
			ifTrue:[^ret3]
			ifFalse:[^0]
			]
		]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/2/2013 00:24'!
checkWinningWithDiagonal: subMatrix

	| ret1 ret2  |
	ret1 := (self checkWinningWithSet: ((subMatrix diagonal) asSet)).
	ret2 := (self checkWinningWithSet: ( Set newFrom: { (subMatrix at: 1 at: 3). (subMatrix at: 2 at: 2). (subMatrix at: 3 at: 1)}  )).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[^0]
		]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/2/2013 00:24'!
checkWinningWithRow: subMatrix

	| ret1 ret2 ret3 |
	ret1 := (self checkWinningWithSet: ((subMatrix atRow: 1) asSet)).
	ret2 := (self checkWinningWithSet: ((subMatrix atRow: 2) asSet)).
	ret3 := (self checkWinningWithSet: ((subMatrix atRow: 3) asSet)).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[ret3 > 0
			ifTrue:[^ret3]
			ifFalse:[^0]
			]
		]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/2/2013 00:32'!
checkWinningWithSet: aSet

	|  |
	(aSet size = 1)
	ifTrue:["judge"
		(aSet includes: 1)
		ifTrue:[ ^1 ]
		ifFalse:[
			(aSet includes: 2)
				ifTrue:[ ^2 ]
				ifFalse:[ ^0 ].
			]
		]
	ifFalse:[^0]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/2/2013 00:25'!
checkWinningWithSubMatrix: subMatrix

	| ret1 ret2 ret3 |
	ret1 := (self checkWinningWithRow: subMatrix).
	ret2 := (self checkWinningWithCol: subMatrix).
	ret3 := (self checkWinningWithDiagonal: subMatrix).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[ret3 > 0
			ifTrue:[^ret3]
			ifFalse:[^0]
			]
		]! !

!UT3Board methodsFor: 'private' stamp: 'ShineLow 7/4/2013 14:25'!
getWinnerAtSet: aSet
	|winnerCell|
	(aSet size = 1) ifFalse: [ ^#none ].
	winnerCell := aSet atRandom.
	(winnerCell state = #empty | winnerCell state = #undecided) ifTrue: [ ^#none ] ifFalse: [ ^ winnerCell state ]! !

!UT3Board methodsFor: 'Play Game' stamp: 'Oliver 7/2/2013 00:36'!
ifplayer: aPlayer moveRow: aMoveRow moveCol: aMoveCol
	
	"aPlayer is 1 of int for playerA and 2 of int for playerB"
	|  |
	( (aPlayer) == (boardMatrix at: aMoveRow at: aMoveCol ))
	ifTrue:[ ^true ]
	ifFalse:[ ^false ].
	
! !

!UT3Board methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 17:09'!
initialize 
	^ self subclassResponsibility! !

!UT3Board methodsFor: 'Play Game' stamp: 'Oliver 7/5/2013 00:43'!
player: aPlayer moveRow: aMoveRow moveCol: aMoveCol
	
	| tempRow tempCol subMatrix ret1 tempBoardToPlay |
	(turnOfPlayer ~= aPlayer)
	ifTrue:[ self error: 'It is the other players turn!!!!'  ]
	ifFalse:["go ahead and play the move as below"].
	
	"aPlayer is 1 of int for playerA and 2 of int for playerB"
	( (0) == (boardMatrix at: aMoveRow at: aMoveCol ))
	ifTrue:[ 
		(aPlayer = 2)
		ifTrue:[ "check if the board to play is right"
			tempRow := (aMoveRow - (aMoveRow % 3)) / 3  + 1.
			tempCol := (aMoveCol - (aMoveCol % 3)) / 3  + 1.
			tempBoardToPlay := #(tempRow tempCol).
			( nextBoardToPlay = tempBoardToPlay )
			ifTrue:["the right board"
				boardMatrix at: aMoveRow at: aMoveCol put: aPlayer.  
				]
			ifFalse:[ self error: 'Not the right board to play!!'  ]
		]
		ifFalse:[
			boardMatrix at: aMoveRow at: aMoveCol put: aPlayer.
		]
	]
	ifFalse:[ 
		self error: 'Player could only be 1 or 2 and one can only play in an empty slot!!'   
	].
	"switch next turn for the other player"
	turnOfPlayer := 3 - turnOfPlayer.
	"update the board to play nextBoardToPlay"
	tempRow := (aMoveRow - (aMoveRow % 3)) / 3  + 1.
	tempCol := (aMoveCol - (aMoveCol % 3)) / 3  + 1.
	nextBoardToPlay := #(tempRow tempCol).
	
	"check if anybody wins any subBoard or the game"
	tempRow := (aMoveRow - (aMoveRow % 3))  + 1.
	tempCol := (aMoveCol - (aMoveCol % 3))  + 1.
	subMatrix := boardMatrix atRows: tempRow to: (tempRow+2) columns: tempCol to: (tempCol+2).
	
	ret1 := self checkWinningWithSubMatrix: subMatrix.
	ret1 > 0
	ifTrue:[
		tempRow := (tempRow -1)/3 + 1.
		tempCol := (tempCol -1)/3 + 1.
		boardGlobalMatrix at: tempRow at: tempCol put: ret1
		]
	ifFalse:[	 "nobody wins anything in this move, so nothing to do here ATM"	].
			
	"check if anybody wins the game"
	
	! !

!UT3Board methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 14:39'!
printBoardOn: aStream
	^ self subclassResponsibility ! !

!UT3Board methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 14:39'!
printBoardString
	|stream|
	stream := WriteStream on: ( String new ).
	self printBoardOn: stream.
	^ stream contents! !

!UT3Board methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 16:57'!
printOn: aStream
	" prints the gameboard on a stream"
	self printBoardOn: aStream! !

!UT3Board methodsFor: 'private' stamp: 'ShineLow 7/4/2013 17:15'!
size
	^ size! !

UT3Board subclass: #UT3NestedBoard
	instanceVariableNames: 'boardMatrix movesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3NestedBoard commentStamp: '<historical>' prior: 0!
An UT3NestedBoard is a TicTacToe Board that implements the Ultimate Tic Tac Toe game. It holds a matrix of regular TicTacToe boards, and each move will need to specify column and row of both the larger board and smaller board.

Instance Variables
	boardMatrix:		<Object>

boardMatrix
	- xxxxx
!

!UT3NestedBoard methodsFor: 'Play Game' stamp: 'ShineLow 7/4/2013 18:07'!
at: anArray subBoard: subArray put: aSymbol
	|row column subRow subColumn subBoard|
	(aSymbol = #circle) | (aSymbol = #cross) ifFalse: [ MoveError signal: 'Unknown move symbol.' ].
	row := anArray first.
	column := anArray second.
	subRow := subArray first.
	subColumn := subArray second.
	subBoard := boardMatrix at: row at: column.
	subBoard isFull ifTrue: [ MoveError signal: 'Subboard already full' ].
	(subBoard canPutAtRow: subRow column: subColumn) ifFalse: [ MoveError signal: 'Subboard cell filled' ].
	
	subBoard atRow: subRow column: subColumn put: aSymbol.
	movesCount := movesCount + 1.
	movesList add: { anArray. subArray }.
	"Every time we make a move, we check to see if a winner is already decided"	
	( (subBoard winner = #cross) | (subBoard winner = #circle) ) ifTrue: [ 
		self checkWinnerAtRow: row column: column matrix: boardMatrix ].
	"If this is the last move, and we still don't have a winner, set winner as none"
	(self isFull) & (winner = #undecided) ifTrue: [ winner := #none ]
	! !

!UT3NestedBoard methodsFor: 'Play Game' stamp: 'ShineLow 7/4/2013 17:58'!
canMoveAt: anArray subBoard: subArray 
	"A move is valid if only the current coordinate is the same as the previous subArray coordinate.
	If the target board is already full, then the move is valid at any location."
	| row column subRow subColumn lastMove expectedArray |
	row := anArray first.
	column := anArray second.
	subRow := subArray first.
	subColumn := subArray second.
	(movesList size = 0) ifTrue: [ ^ true ].
	lastMove := movesList last.
	expectedArray := lastMove second.
	( anArray = expectedArray )
	ifTrue: [ ^ (boardMatrix at: row at: column) canPutAtRow: subRow column: subColumn ]
	ifFalse: [ (boardMatrix at: expectedArray first at: expectedArray second) isFull
			  ifTrue: [ ^ (boardMatrix at: row at: column) canPutAtRow: subRow column: subColumn ] ].
	^ false! !

!UT3NestedBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 13:25'!
initialize
	size := 3. "Default board size is 3x3"
	boardMatrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3BasicBoard new ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3NestedBoard methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 14:50'!
isFull
	boardMatrix do: [ :subBoard | subBoard isFull ifFalse: [ ^false ] ].
	^ true! !

!UT3NestedBoard methodsFor: 'Play Game' stamp: 'ShineLow 7/4/2013 14:37'!
player: aPlayer moveRow: aMoveRow moveCol: aMoveCol
	|symbol row column subRow subColumn|
	aPlayer = 1 ifTrue: [ symbol := #circle ] ifFalse: [ symbol := #cross ].
	row := (aMoveRow / size) asFraction ceiling.
	column := ( aMoveCol / size ) asFraction ceiling.
	subRow := aMoveRow % size.
	(subRow = 0) ifTrue: [ subRow := size ].
	subColumn := aMoveCol % size.
	( subColumn = 0 ) ifTrue: [ subColumn := size ].
	self at: { row. column } subBoard: { subRow. subColumn } put: symbol! !

!UT3NestedBoard methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 16:43'!
printBoardOn: aStream
	|subBoardSize|
	subBoardSize := (boardMatrix at: 1 at: 1) size.
	(1 to: size) do: [ :row |
		(1 to: subBoardSize) do: [ :subRow |
			(1 to: size) do: [ :column |
				(boardMatrix at: row at: column) printRow: subRow on: aStream. ]
					    separatedBy: [ aStream nextPutAll: ' || '  ].
			aStream cr.
		].
		aStream cr.
	].! !

!UT3NestedBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 17:08'!
resetWithSize: anInteger
	size := anInteger. "Default board size is 3x3"
	boardMatrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3BasicBoard newWithSize: anInteger ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3NestedBoard methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 14:44'!
winner
	^ winner! !

Object subclass: #UT3Cell
	instanceVariableNames: 'state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3Cell commentStamp: '<historical>' prior: 0!
An UT3Cell is class representing a Cell in a Board.

Instance Variables
	state:		<Object>

state
	- xxxxx
!

!UT3Cell methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 11:23'!
= aCell
	^ state = aCell state! !

!UT3Cell methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 12:16'!
hash
	^ state hash! !

!UT3Cell methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 10:18'!
initialize
	state := #empty! !

!UT3Cell methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 10:26'!
printOn: aStream
	aStream nextPutAll: 'Cell with '.
	state = #empty ifTrue: [ aStream nextPutAll: 'nothing' ]
					 ifFalse: [ state = #circle ifTrue: [ aStream nextPutAll: 'O' ]
											  ifFalse: [ aStream nextPutAll: 'X' ] ]! !

!UT3Cell methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 16:37'!
printStateOn: aStream 
		state = #empty ifTrue: [ aStream nextPutAll: '    ' ]
					 ifFalse: [ state = #circle ifTrue: [ aStream nextPutAll: ' 0 ' ]
											  ifFalse: [ aStream nextPutAll: ' x ' ] ]! !

!UT3Cell methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 10:24'!
setCircle
	state = #empty ifFalse: [ MoveError signal ].
	state := #circle! !

!UT3Cell methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 10:25'!
setCross
	state = #empty ifFalse: [ MoveError signal ].
	state := #cross! !

!UT3Cell methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 10:22'!
state
	^ state! !

Object subclass: #UT3System
	instanceVariableNames: 'board currentPlayer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3System commentStamp: '<historical>' prior: 0!
An UT3System is the class encapsulating an entire Ultimate TicTacToe game.

It contains an interface to make moves for each player, and holds an instance of UT3Board that represents the game board state, and is stateful in the sense that it records each player's move.

You can use the provided API to get the which player's turn it is, etc. Invalid moves will throw MoveError.

Instance Variables
!
